;;; DO NOT MODIFY THIS FILE
(if (featurep 'semantic-custom-defines) (error "Feature semantic-custom-defines already loaded"))

;;;### (autoloads (document-new-hist-comment document-autocomment-param-type-alist document-autocomment-param-alist document-autocomment-return-last-alist document-autocomment-return-first-alist document-autocomment-common-nouns-abbrevs document-autocomment-function-alist document-date-element document-history-element document-param-element document-function-comment document-file-brief-comment document-header-comment document-file-comment document-extra-line-after-short-parameters document-change-number document-copyright-notice-file) "document-vars" "semantic/document-vars.el")
(defconst custom-define-current-source-file "document-vars.el")

(defcustom document-copyright-notice-file nil "\
*A file name containing a copyright notice.
It will be reformatted in the header to have the correct prefix character.
See the %N token in `document-file-comment'" :group 'document :type 'file)

(defcustom document-change-number nil "\
*The current change number being worked on.
Large projects may use change numbers, bug numbers, or other tag." :group 'document :type 'string)

(defcustom document-extra-line-after-short-parameters t "\
*Non-nil to add an extra line when there is < 1 arguments." :group 'document :type 'string)

(defcustom document-file-comment "%s %B\n%m\n%m Copyright (C) %Y %O\n%m\n%m %N\n%m\n%m Description:\n%m\n%m   %D\n%m\n%m History:\n%m %H\n%m\n%m Tokens: %T\n%e\n" "\
Comment block for the beginning of a new file.
The format tokens available are:
 %B - Brief description of the file (Auto-comment by file name)
 %D - Made up documentation
 %N - Copyright notice for your organization
 %O - Owner (full name of copyright holder held in `document-copyright-holder'
 %H - History elements
 %T - cproto header id token.  Always is form 'token file.h' where
      token is defined in cpr-header-token, and file.h is the
      relational file name of the header.  If you wish to use cproto's
      features, you must have this somewhere in the header.
 %Y - Year
Commenting elements:
 %b - Comment start string
 %m - Comment line prefix (not the start)
 %e - Comment end string" :group 'document :type 'string)

(defcustom document-header-comment "%b\n%m Copyright (c) %Y %O\n%m\n%m %N\n%m\n%m History:\n%m %H\n%e\n" "\
Comment block for the beginning of a new header/dependency file.
The format tokens available are the same as for `document-file-comment'" :group 'document :type 'string)

(defcustom document-file-brief-comment "%F - %C" "\
Format of the brief comment with tokens.
Available tokens are:
 %F - file name short
 %C - Comment field" :group 'document :type 'string)

(defcustom document-function-comment "\^L\n%b\n%m Function: %F\n%m\n%m %f  %D%p\n%m\n%m Returns:     %R\n%m Parameters:  %P\n%m History:\n%m %H\n%e\n" "\
Comment block for the beginning of a new function/variable definition.
There are several format tokens represent the following:
  %F - function name
  %D - Made up documentation
  %f - Place, where everything before the point is the distance to set
       in the fill prefix.  Allows a first line in paragraph indent
  %p - Where to place point after insertion of a new header
  %R - Returns
  %P - Parameter list
  %H - History insertion point

  The parts %f and %p can be confusing, so here is an example:

 * Moose: %f%D%p

 Will set fill prefix to ` *         `, and put the point AFTER the
description.  The `Moose:` will not be in the prefix.  The default
value shows the equivalent of a hanging indent.

Commenting elements:
 %b - Comment start string
 %m - Comment line prefix (not the start)
 %e - Comment end string" :group 'document :type 'string)

(defcustom document-param-element "%P - %D" "\
The format of a parameter element in the list of parameters.
The parts are:
 %P - Parameter name spaced to length of max param
 %p - Parameter name with no padding
 %R - Type of element
 %D - Description of parameter as known by document." :group 'document :type 'string)

(defcustom document-history-element "%-7U %-10D %C" "\
Format for history element.
Valid % codes are:
  %U - Username, initials, what have you.
  %D - The current date formatted as in `document-date-element'
  %S - System Change id, SCCS vers, major change comment, etc
  %C - Auto comment area, cursor goes here for new elts." :group 'document :type 'string)

(defcustom document-date-element "%M/%D/%y" "\
Format for date elements.
Valid format chars are:
  %H - Hours
  %h - Hours 24 hr format
  %a - AM/PM flag
  %I - mInutes
  %S - Seconds
  %D - Day
  %w - Weekday string
  %M - Month as number
  %m - Month as string
  %Y - Year
  %y - Year as 2 numbers 1994 -> 94" :group 'document :type 'string)

(defcustom document-autocomment-function-alist '(("abort" . "Aborts the") ("realloc" . "moves or ") ("alloc\\(ate\\)?" . "Allocates and initializes a new ") ("clean" . "Cleans up the") ("clobber" . "Removes") ("close" . "Cleanly closes") ("check" . "Checks the") ("comp\\(are\\)?" . "Compares the") ("create" . "Creates a new ") ("find" . "Finds ") ("free" . "Frees up space") ("gen\\(erate\\)?" . "Generates a new ") ("get\\|find" . "Looks for the given ") ("gobble" . "Removes") ("he?lp" . "Provides help for") ("li?ste?n" . "Listens for ") ("connect" . "Connects to ") ("acc?e?pt" . "Accepts a ") ("load" . "Loads in ") ("match" . "Check that parameters match") ("name" . "Provides a name which ") ("parse" . "Parses the parameters and returns ") ("print\\|display" . "Prints out") ("read" . "Reads from") ("reset" . "Resets the parameters and returns") ("scan" . "Scans the ") ("setup\\|init\\(iallize\\)?" . "Initializes the ") ("select" . "Chooses the ") ("send" . "Sends a") ("re?c\\(v\\|ieves?\\)" . "Receives a ") ("wait" . "Waits for ") ("write" . "Writes to")) "\
List of names to string match against the function name.
This is an alist with each element of the form:
 (MATCH . RESULT)
MATCH is a regexp to match in the type field.
RESULT is a string.

Certain prefixes may always mean the same thing, and the same comment
can be used as a beginning for the description.  Regexp should be
lower case since the string they are compared to is downcased.
A string may end in a space, in which case, last-alist is searched to
see how best to describe what can be returned.
Doesn't always work correctly, but that is just because English
doesn't always work correctly." :group 'document :type '(repeat (cons (string :tag "Regexp") (string :tag "Doc Text"))))

(defcustom document-autocomment-common-nouns-abbrevs '(("sock\\(et\\)?" . "socket") ("addr\\(ess\\)?" . "address") ("buf\\(f\\(er\\)?\\)?" . "buffer") ("cur\\(r\\(ent\\)?\\)?" . "current") ("dev\\(ice\\)?" . "device") ("file" . "file") ("line" . "line") ("msg\\|message" . "message") ("name" . "name") ("next\\|nxt" . "next") ("port" . "port") ("host" . "host") ("obj\\|object" . "object") ("previous\\|prev" . "previous") ("str\\(ing\\)?" . "string") ("use?r" . "user") ("num\\(ber\\)?" . "number") ("\\(^\\|\\s-\\)id\\($\\|\\s-\\)" . "Identifier")) "\
List of common English abbreviations or full words.
These are nouns (as opposed to verbs) for use in creating expanded
versions of names.This is an alist with each element of the form:
 (MATCH . RESULT)
MATCH is a regexp to match in the type field.
RESULT is a string." :group 'document :type '(repeat (cons (string :tag "Regexp") (string :tag "Doc Text"))))

(defcustom document-autocomment-return-first-alist '(("static" . "Locally defined function which ") ("Bool\\|BOOL" . "Status of ")) "\
List of regexp matches for types.
They provide a little bit of text when typing information is
described.
This is an alist with each element of the form:
 (MATCH . RESULT)
MATCH is a regexp to match in the type field.
RESULT is a string." :group 'document :type '(repeat (cons (string :tag "Regexp") (string :tag "Doc Text"))))

(defcustom document-autocomment-return-last-alist '(("static[ 	\n]+struct \\([a-zA-Z0-9_]+\\)" . "%s") ("struct \\([a-zA-Z0-9_]+\\)" . "%s") ("static[ 	\n]+union \\([a-zA-Z0-9_]+\\)" . "%s") ("union \\([a-zA-Z0-9_]+\\)" . "%s") ("static[ 	\n]+enum \\([a-zA-Z0-9_]+\\)" . "%s") ("enum \\([a-zA-Z0-9_]+\\)" . "%s") ("static[ 	\n]+\\([a-zA-Z0-9_]+\\)" . "%s") ("\\([a-zA-Z0-9_]+\\)" . "of type %s")) "\
List of regexps which provide the type of the return value.
This is an alist with each element of the form:
 (MATCH . RESULT)
MATCH is a regexp to match in the type field.
RESULT is a string, which can contain %s, whih is replaced with
`match-string' 1." :group 'document :type '(repeat (cons (string :tag "Regexp") (string :tag "Doc Text"))))

(defcustom document-autocomment-param-alist '(("[Cc]txt" . "Context") ("[Ii]d" . "Identifier of") ("[Tt]ype" . "Type of") ("[Nn]ame" . "Name of") ("argc" . "Number of arguments") ("argv" . "Argument vector") ("envp" . "Environment variable vector")) "\
Alist of common variable names appearing as function parameters.
This is an alist with each element of the form:
 (MATCH . RESULT)
MATCH is a regexp to match in the type field.
RESULT is a string of text to use to describe MATCH.
When one is encountered, document-insert-parameters will automatically
place this comment after the parameter name." :group 'document :type '(repeat (cons (string :tag "Regexp") (string :tag "Doc Text"))))

(defcustom document-autocomment-param-type-alist '(("const" . "Constant") ("void" . "Empty") ("char[ ]*\\*" . "String ") ("\\*\\*" . "Pointer to ") ("\\*" . "Pointer ") ("char[ ]*\\([^ 	*]\\|$\\)" . "Character") ("int\\|long" . "Number of") ("FILE" . "File of") ("float\\|double" . "Value of") ("Bool\\|BOOL" . "Flag") ("Window" . "Window") ("GC" . "Graphic Context") ("Widget" . "Widget")) "\
Alist of input parameter types and strings desribing them.
This is an alist with each element of the form:
 (MATCH . RESULT)
MATCH is a regexp to match in the type field.
RESULT is a string." :group 'document :type '(repeat (cons (string :tag "Regexp") (string :tag "Doc Text"))))

(defcustom document-new-hist-comment "Created" "\
Comment used in the history when something is created." :group 'document :type 'string)

;;;***

;;;### (autoloads (document-copyright-holder document-my-initials document) "document" "semantic/document.el")
(defconst custom-define-current-source-file "document.el")

(defgroup document nil "File and tag browser frame." :group 'semantic :group 'texinfo)

(defcustom document-my-initials (user-login-name) "\
*The initials to use when commenting something." :group 'document :type 'string)

(defcustom document-copyright-holder (user-full-name) "\
*The string to use as the copyright holder in the file comment." :group 'document :type 'string)

;;;***

;;;### (autoloads (semantic-analyze-summary-function) "semantic-analyze" "semantic/semantic-analyze.el")
(defconst custom-define-current-source-file "semantic-analyze.el")

(defcustom semantic-analyze-summary-function 'semantic-prototype-nonterminal "\
*Function to use when creating items in Imenu.
Some useful functions are found in `semantic-token->text-functions'." :group 'semantic :type semantic-token->text-custom-list)

;;;***

;;;### (autoloads (semantic-default-c-path) "semantic-c" "semantic/semantic-c.el")
(defconst custom-define-current-source-file "semantic-c.el")

(defcustom semantic-default-c-path '("/usr/include" "/usr/dt/include" "/usr/X11R6/include") "\
Default set of include paths for C code.
Used by `semantic-inc' to define an include path.  This should
probably do some sort of search to see what is actually on the local
machine." :group 'c :type '(repeat (string :tag "Path")))

;;;***

;;;### (autoloads (se-summary-function) "semantic-example" "semantic/semantic-example.el")
(defconst custom-define-current-source-file "semantic-example.el")

(defcustom se-summary-function 'semantic-uml-prototype-nonterminal "\
*Function to use when showing info about a token for Examples.
Shows how to:
  * Create a customization variable." :group 'semantic :type semantic-token->text-custom-list)

;;;***

;;;### (autoloads (semantic-ia-completion-token->text semantic-ia-completion-token->text) "semantic-ia" "semantic/semantic-ia.el")
(defconst custom-define-current-source-file "semantic-ia.el")

(defcustom semantic-ia-completion-token->text 'semantic-prototype-nonterminal "\
*Function used to convert a token to a string during completion." :group 'semantic :type semantic-token->text-custom-list)

(defcustom semantic-ia-completion-token->text 'semantic-uml-concise-prototype-nonterminal "\
*Function used to convert a token to a string during completion." :group 'semantic :type semantic-token->text-custom-list)

;;;***

;;;### (autoloads (semantic-which-function-use-color semantic-imenu-auto-rebuild-directory-indexes semantic-imenu-index-directory semantic-imenu-sort-bucket-function semantic-imenu-bucketize-type-parts semantic-imenu-expand-type-parts semantic-imenu-buckets-to-submenu semantic-imenu-adopt-external-members semantic-imenu-bucketize-file semantic-imenu-summary-function semantic-imenu) "semantic-imenu" "semantic/semantic-imenu.el")
(defconst custom-define-current-source-file "semantic-imenu.el")

(defgroup semantic-imenu nil "Parser Generator Imenu interface." :group 'semantic :group 'imenu)

(defcustom semantic-imenu-summary-function 'semantic-abbreviate-nonterminal "\
*Function to use when creating items in Imenu.
Some useful functions are found in `semantic-token->text-functions'." :group 'semantic-imenu :type semantic-token->text-custom-list)

(defcustom semantic-imenu-bucketize-file t "\
*Non-nil if tokens in a file are to be grouped into buckets." :group 'semantic-imenu :type 'boolean)

(defcustom semantic-imenu-adopt-external-members t "\
*Non-nil if types in a file should adopt externally defined members.
C++ and CLOS can define methods that are not in the body of a class
definition." :group 'semantic-imenu :type 'boolean)

(defcustom semantic-imenu-buckets-to-submenu t "\
*Non-nil if buckets of tokens are to be turned into submenus.
This option is ignored if `semantic-imenu-bucketize-file' is nil." :group 'semantic-imenu :type 'boolean)

(defcustom semantic-imenu-expand-type-parts t "\
*Non-nil if types should have submenus with parts in it." :group 'semantic-imenu :type 'boolean)

(defcustom semantic-imenu-bucketize-type-parts t "\
*Non-nil if elements of a type should be placed grouped into buckets.
Nil means to keep them in the same order.
Overriden to nil if `semantic-imenu-bucketize-file' is nil." :group 'semantic-imenu :type 'boolean)

(defcustom semantic-imenu-sort-bucket-function nil "\
*Function to use when sorting tags in the buckets of functions." :group 'semantic-imenu :type 'function)

(defcustom semantic-imenu-index-directory t "\
*Non nil to index the entire directory for tags.
Doesn't actually parse the entire directory, but displays tags for all files
currently listed in the current Semantic database.
This variable has no meaning if semanticdb is not active." :group 'semantic-imenu :type 'boolean)

(defcustom semantic-imenu-auto-rebuild-directory-indexes t "\
*If non-nil automatically rebuild directory index imenus.
That is when a directory index imenu is updated, automatically rebuild
other buffer local ones based on the same semanticdb." :group 'semantic-imenu :type 'boolean)

(defcustom semantic-which-function-use-color nil "\
*Use color when displaying the current function with `which-function'." :group 'semantic-imenu :type 'boolean)

;;;***

;;;### (autoloads (semantic-sb-info-token->text-function semantic-sb-button-token->text-function semantic-sb-autoexpand-length) "semantic-sb" "semantic/semantic-sb.el")
(defconst custom-define-current-source-file "semantic-sb.el")

(defcustom semantic-sb-autoexpand-length 1 "\
*Length of a semantic bucket to autoexpand in place.
This will replace the named bucket that would have usually occured here." :group 'speedbar :type 'integer)

(defcustom semantic-sb-button-token->text-function 'semantic-abbreviate-nonterminal "\
*Function called to create the text for a but from a token." :group 'speedbar :type semantic-token->text-custom-list)

(defcustom semantic-sb-info-token->text-function 'semantic-summarize-nonterminal "\
*Function called to create the text for info display from a token." :group 'speedbar :type semantic-token->text-custom-list)

;;;***

;;;### (autoloads (semantic-default-scheme-path) "semantic-scm" "semantic/semantic-scm.el")
(defconst custom-define-current-source-file "semantic-scm.el")

(defcustom semantic-default-scheme-path '("/usr/share/guile/") "\
Default set of include paths for scheme (guile) code.
Used by `semantic-inc' to define an include path.  This should
probably do some sort of search to see what is actually on the local
machine." :group 'scheme :type '(repeat (string :tag "Path")))

;;;***

;;;### (autoloads (semantic-stickyfunc-mode-hook global-semantic-stickyfunc-mode semantic-summary-mode-hook global-semantic-summary-mode semantic-auto-parse-mode-hook global-semantic-auto-parse-mode semantic-auto-parse-max-buffer-size semantic-auto-parse-idle-time semantic-auto-parse-working-in-modeline-flag semantic-auto-parse-no-working-message semantic-show-unmatched-syntax-mode-hook global-semantic-show-unmatched-syntax-mode semantic-show-dirty-mode-hook global-semantic-show-dirty-mode semantic-mode-line-prefix semantic-update-mode-line) "semantic-util-modes" "semantic/semantic-util-modes.el")
(defconst custom-define-current-source-file "semantic-util-modes.el")

(defcustom semantic-update-mode-line t "\
*If non-nil, show enabled minor modes in the mode line.
Only minor modes that are not turned on globally are shown in the mode
line." :group 'semantic :type 'boolean :require 'semantic-util-modes :initialize 'custom-initialize-default :set (lambda (sym val) (set-default sym val) (semantic-map-buffers (function semantic-mode-line-update))))

(defcustom semantic-mode-line-prefix (semantic-propertize "S" 'face 'bold) "\
*Prefix added to minor mode indicators in the mode line." :group 'semantic :type 'string :require 'semantic-util-modes :initialize 'custom-initialize-default)

(defcustom global-semantic-show-dirty-mode nil "\
*If non-nil, enable global use of show-dirty mode." :group 'semantic :type 'boolean :require 'semantic-util-modes :initialize 'custom-initialize-default :set (lambda (sym val) (global-semantic-show-dirty-mode (if val 1 -1))))

(defcustom semantic-show-dirty-mode-hook nil "\
*Hook run at the end of function `semantic-show-dirty-mode'." :group 'semantic :type 'hook)

(defcustom global-semantic-show-unmatched-syntax-mode nil "\
*If non-nil, enable global use of show-unmatched-syntax mode." :group 'semantic :type 'boolean :require 'semantic-util-modes :initialize 'custom-initialize-default :set (lambda (sym val) (global-semantic-show-unmatched-syntax-mode (if val 1 -1))))

(defcustom semantic-show-unmatched-syntax-mode-hook nil "\
*Hook run at the end of function `semantic-show-unmatched-syntax-mode'." :group 'semantic :type 'hook)

(defcustom semantic-auto-parse-no-working-message t "\
*If non-nil, disable display of working messages during parse." :group 'semantic :type 'boolean)

(defcustom semantic-auto-parse-working-in-modeline-flag nil "\
*Non-nil means show working messages in the mode line.
Typically, parsing will show messages in the minibuffer.
This will move the parse message into the modeline." :group 'semantic :type 'boolean)

(defcustom semantic-auto-parse-idle-time 4 "\
*Time in seconds of idle time before auto-reparse.
This time should be short enough to ensure that auto-parse will be
run as soon as Emacs is idle." :group 'semantic :type 'number :set (lambda (sym val) (set-default sym val) (when (timerp semantic-auto-parse-timer) (cancel-timer semantic-auto-parse-timer) (setq semantic-auto-parse-timer nil) (semantic-auto-parse-setup-timer))))

(defcustom semantic-auto-parse-max-buffer-size 0 "\
*Maximum size in bytes of buffers automatically reparsed.
If this value is less than or equal to 0, buffers are automatically
reparsed regardless of their size." :group 'semantic :type 'number)

(defcustom global-semantic-auto-parse-mode nil "\
*If non-nil, enable global use of auto-parse mode." :group 'semantic :type 'boolean :require 'semantic-util-modes :initialize 'custom-initialize-default :set (lambda (sym val) (global-semantic-auto-parse-mode (if val 1 -1))))

(defcustom semantic-auto-parse-mode-hook nil "\
*Hook run at the end of function `semantic-show-dirty-mode'." :group 'semantic :type 'hook)

(defcustom global-semantic-summary-mode nil "\
*If non-nil, enable global use of summary mode." :group 'semantic :type 'boolean :require 'semantic-util-modes :initialize 'custom-initialize-default :set (lambda (sym val) (global-semantic-summary-mode (if val 1 -1))))

(defcustom semantic-summary-mode-hook nil "\
*Hook run at the end of function `semantic-summary-mode'." :group 'semantic :type 'hook)

(defcustom global-semantic-stickyfunc-mode nil "\
*If non-nil, enable global use of stickyfunc mode." :group 'semantic :type 'boolean :require 'semantic-util-modes :initialize 'custom-initialize-default :set (lambda (sym val) (global-semantic-stickyfunc-mode (if val 1 -1))))

(defcustom semantic-stickyfunc-mode-hook nil "\
*Hook run at the end of function `semantic-stickyfunc-mode'." :group 'semantic :type 'hook)

;;;***

;;;### (autoloads (semantic-uml-no-protection-string semantic-uml-colon-string) "semantic-util" "semantic/semantic-util.el")
(defconst custom-define-current-source-file "semantic-util.el")

(defcustom semantic-uml-colon-string " : " "\
*String used as a color separator between parts of a UML string.
In UML, a variable may appear as `varname : type'.
Change this variable to change the output separator." :group 'semantic :type 'string)

(defcustom semantic-uml-no-protection-string "" "\
*String used to describe when no protection is specified.
Used by `semantic-uml-protection-to-string'." :group 'semantic :type 'string)

;;;***

;;;### (autoloads (semantic-dump-parse semantic) "semantic" "semantic/semantic.el")
(defconst custom-define-current-source-file "semantic.el")

(defgroup semantic nil "Parser Generator/Parser.")

(defcustom semantic-dump-parse nil "\
When non-nil, dump parsing information." :group 'semantic :type 'boolean)

;;;***

;;;### (autoloads (semanticdb-project-roots semanticdb-save-database-hooks semanticdb-mode-hooks semanticdb-persistent-path semanticdb-default-save-directory semanticdb-default-file-name semanticdb-global-mode semanticdb) "semanticdb" "semantic/semanticdb.el")
(defconst custom-define-current-source-file "semanticdb.el")

(defgroup semanticdb nil "Parser Generator Persistent Database interface." :group 'semantic)

(defcustom semanticdb-global-mode nil "\
*If non-nil enable the use of `semanticdb-minor-mode'." :group 'semantic :type 'boolean :require 'semanticdb :initialize 'custom-initialize-default :set (lambda (sym val) (global-semanticdb-minor-mode (if val 1 -1)) (custom-set-default sym val)))

(defcustom semanticdb-default-file-name "semantic.cache" "\
*File name of the semantic token cache." :group 'semanticdb :type 'string)

(defcustom semanticdb-default-save-directory nil "\
*Directory name where semantic cache files are stored.
If this value is nil, files are saved in the current directory. If the value
is a valid directory, then it overrides `semanticdb-default-file-name' and
stores caches in a coded file name in this directory." :group 'semanticdb :type '(choice :tag "Default-Directory" :menu-tag "Default-Directory" (const :tag "Use current directory" :value nil) (directory)))

(defcustom semanticdb-persistent-path '(project) "\
*List of valid paths that semanticdb will cache tokens to.
When `global-semanticdb-minor-mode' is active, token lists will
be saved to disk when Emacs exits.  Not all directories will have
tokens that should be saved.
The value should be a list of valid paths.  A path can be a string,
indicating a directory in which to save a variable.  An element in the
list can also be a symbol.  Valid symbols are `never', which will
disable any saving anywhere, `always', which enables saving
everywhere, or `project', which enables saving in any directory that
passes a list of predicates in `semantic-project-predicates'." :group 'semanticdb :type nil)

(defcustom semanticdb-mode-hooks nil "\
*Hooks run whenever `global-semanticdb-minor-mode' is run.
Use `semanticdb-minor-mode-p' to determine if the mode has been turned
on or off." :group 'semanticdb :type 'hook)

(defcustom semanticdb-save-database-hooks nil "\
*Hooks run after a database is saved.
Each function is called with one argument, the object representing
the database recently written." :group 'semanticdb :type 'hook)

(defcustom semanticdb-project-roots nil "\
*List of directories, where each directory is the root of some project.
All subdirectories of a root project are considered a part of one project.
Values in this string can be overriden by project management programs
via the `semanticdb-project-root-functions' variable." :group 'semanticdb :type '(repeat string))

;;;***

;;;### (autoloads (senator-eldoc-use-color senator-mode-menu-item-format-tty senator-mode-menu-item-format senator-completion-menu-insert-function senator-completion-menu-summary-function senator-highlight-found senator-step-at-start-end-token-ids senator-step-at-token-ids senator-minor-mode-hook global-senator-minor-mode senator) "senator" "semantic/senator.el")
(defconst custom-define-current-source-file "senator.el")

(defgroup senator nil "SEmantic NAvigaTOR." :group 'semantic)

(defcustom global-senator-minor-mode nil "\
*If non-nil enable global use of senator minor mode." :group 'senator :type 'boolean :require 'senator :initialize 'custom-initialize-default :set (lambda (sym val) (global-senator-minor-mode (if val 1 -1))))

(defcustom senator-minor-mode-hook nil "\
Hook run at the end of function `senator-minor-mode'." :group 'senator :type 'hook)

(defcustom senator-step-at-token-ids nil "\
*List of token identifiers where to step.
Token identifier is symbol 'variable, 'function, 'type, or other.  If
nil navigation steps at any token found.  This is a buffer local
variable.  It can be set in a mode hook to get a specific langage
navigation." :group 'senator :type '(repeat (symbol)))

(defcustom senator-step-at-start-end-token-ids '(function) "\
*List of token identifiers where to step at start and end.
Token identifier is symbol 'variable, 'function, 'type, or other.  If
nil navigation only step at beginning of tokens.  If t step at start
and end of any token where it is allowed to step.  Also, stepping at
start and end of a token prevent stepping inside its children.  This
is a buffer local variable.  It can be set in a mode hook to get a
specific langage navigation." :group 'senator :type '(choice :tag "Identifiers" (repeat :menu-tag "Symbols" (symbol)) (const :tag "All" t)))

(defcustom senator-highlight-found t "\
*If non-nil highlight tokens found.
This option requires semantic 1.3 and above.  This is a buffer
local variable.  It can be set in a mode hook to get a specific
langage behaviour." :group 'senator :type 'boolean)

(defcustom senator-completion-menu-summary-function 'semantic-concise-prototype-nonterminal "\
*Function to use when creating items in completion menu.
Some useful functions are in `semantic-token->text-functions'." :group 'senator :type semantic-token->text-custom-list)

(defcustom senator-completion-menu-insert-function 'senator-completion-menu-insert-default "\
*Function to use to insert an item from completion menu.
It will receive a Semantic token as argument." :group 'senator :type '(radio (const senator-completion-menu-insert-default) (function)))

(defcustom senator-mode-menu-item-format "_ %s" "\
*Format of menu item labels in the \"Modes\" menu.
This format is used when Emacs is displaying through a window system.
The function `format' will receives an unique label string." :group 'senator :type 'string :set (lambda (sym val) (set-default sym val) (setq senator-modes-menu-cache nil)))

(defcustom senator-mode-menu-item-format-tty "%s (%s)" "\
*Format of menu item labels in the \"Modes\" menu.
This format is used when Emacs is using a text-only terminal.
The function `format' will receives the mode name and a label string." :group 'senator :type 'string :set (lambda (sym val) (set-default sym val) (setq senator-modes-menu-cache nil)))

(defcustom senator-eldoc-use-color (or (featurep 'xemacs) (>= emacs-major-version 21)) "\
*Use color for eldoc strings generated with semantic.
Colored text can be printed with the message command with some
versions of Emacs." :group 'senator :type 'boolean)

;;;***

;;;### (autoloads (working-percentage-step working-status-dynamic-type working-status-percentage-type working) "working" "semantic/working.el")
(defconst custom-define-current-source-file "working.el")

(defgroup working nil "Working messages display." :prefix "working" :group 'lisp)

(defcustom working-status-percentage-type 'working-bar-percent-display "\
*Function used to display the percent status.
Functions provided in `working' are:
  `working-percent-display'
  `working-bar-display'
  `working-bar-percent-display'
  `working-percent-bar-display'
  `working-bubble-display'
  `working-bubble-precent-display'
  `working-celeron-percent-display'" :group 'working :type '(choice (const working-percent-display) (const working-bar-display) (const working-bar-percent-display) (const working-percent-bar-display) (const working-bubble-display) (const working-bubble-percent-display) (const working-celeron-percent-display) (const nil)))

(defcustom working-status-dynamic-type 'working-celeron-display "\
*Function used to display an animation indicating progress being made.
Dynamic working types occur when the program does not know how long
it will take ahead of time.  Functions provided in `working' are:
  `working-number-display'
  `working-text-display'
  `working-spinner-display'
  `working-dotgrowth-display'
  `working-celeron-display'
  `working-bounce-display'" :group 'working :type '(choice (const working-number-display) (const working-text-display) (const working-spinner-display) (const working-dotgrowth-display) (const working-celeron-display) (const working-bounce-display) (const nil)))

(defcustom working-percentage-step 2 "\
*Percentage display step.
A number representing how large a step must be taken when working a
percentage display.  A number such as `2' means `2%'." :group 'working ':type 'number)

;;;***

(provide 'semantic-custom-defines)
